<?php

/***************************************************************************************************
****  Text Input with Validation  ******************************************************************
        Validate a text field however you'd like
            
        INFO
            Developed by: Mark Huot
            Date: 2006-10-22
..................................................................................................*/

if ( ! defined('EXT')) {
    exit('Invalid file request'); }


class text_improved {
	var $settings		= array();
	
	var $name			= 'Text: Improved';
	var $version		= '1.0.3';
	var $description	= 'Validate a text field however you\'d like';
	var $settings_exist	= 'y';
	var $docs_url		= 'http://docs.markhuot.com';
	
	//
	// Constructor
	//
	function text_improved($settings='')
	{
		$this->settings = $settings;
	}
	
	
	//
	// Add to Database
	//
	function activate_extension ()
	{
		global $DB;
		
		// -- Add edit_custom_field
		$DB->query(
			$DB->insert_string('exp_extensions', 
				array('extension_id' => '',
					  'class'        => get_class($this),
					  'method'       => 'edit_custom_field',
					  'hook'         => 'publish_admin_edit_field_extra_row',
					  'settings'     => '',
					  'priority'     => 10,
					  'version'      => $this->version,
					  'enabled'      => 'y'
				)
			)
		);
		
		// -- Add edit_publish_ad_post
		$DB->query(
			$DB->insert_string('exp_extensions', 
				array('extension_id' => '',
					  'class'        => get_class($this),
					  'method'       => 'edit_publish_ad_post',
					  'hook'         => 'sessions_start',
					  'settings'     => '',
					  'priority'     => 10,
					  'version'      => $this->version,
					  'enabled'      => 'y'
				)
			)
		);
		
		// -- Add modify_post
		$DB->query(
			$DB->insert_string('exp_extensions',
				array('extension_id' => '',
					  'class'        => get_class($this),
					  'method'       => 'modify_post',
					  'hook'         => 'submit_new_entry_start',
					  'settings'     => '',
					  'priority'     => 10,
					  'version'      => $this->version,
					  'enabled'      => 'y'
				)
			)
		);
	}
	
	//
	// Change Settings
	//
	function settings()
	{
		$settings = array();
		
		$settings['error_messages'] = array('t', 'v:/^[a-z]+$/ l:"The field %f should be composed of all lowercase characters."');
		
		// Complex:
		// [variable_name] => array(type, values, default value)
		// variable_name => short name for setting and used as the key for language file variable
		// type:  t - textarea, r - radio buttons, s - select, ms - multiselect, f - function calls
		// values:  can be array (r, s, ms), string (t), function name (f)
		// default:  name of array member, string, nothing
		//
		// Simple:
		// [variable_name] => 'Butter'
		// Text input, with 'Butter' as the default.
		
		return $settings;
	}
	
	//
	// Update Extension (by FTP)
	//
	function update_extension($current = '')
	{
		global $DB;
		
		if ($current == '' OR $current == $this->version)
		{
			return FALSE;
		}
		if ($current < '1.0.1' )
		{
			/*Update Query*/
		}
		
		$DB->query("UPDATE exp_extensions SET version = '".$DB->escape_str($this->version)."' WHERE class = '".get_class($this)."'");
	}
	
	//
	//  Admin > Field Groups > Edit Custom Field
	//
	function edit_custom_field( $data, $r )
	{
		global $EXT, $LANG;
		$LANG->fetch_language_file('text_improved');
		
		// -- Check if we're not the only one using this hook
		if($EXT->last_call !== false)
		{
			$r = $EXT->last_call;
		}
		
		// -- Modify existing js
		$r = preg_replace("/(id\s*==.*?)\}/s", "$1\t\tdocument.getElementById('validate_block').style.display = \"none\";
		}", $r);
		
		// -- Modify existing text js
		$r = preg_replace("/(id\s*== 'text'.*?)\}/s", "$1\t\tdocument.getElementById('validate_block').style.display = \"block\";
		}", $r);
		
		// -- Add the validate block
		$numeric = $alpha = $alphanumeric = $email = $url = $date = $custom = "";
		switch($data['field_list_items'])
		{
			case "v:/^[0-9]+$/": $numeric = ' selected="selected"'; break;
			case "v:/^[a-z]+$/i": $alpha = ' selected="selected"'; break;
			case "v:/^[a-z0-9]+$/i": $alphanumeric = ' selected="selected"'; break;
			case "v:/^[a-zA-Z][\w\.-]*[a-zA-Z0-9]@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$/": $email = ' selected="selected"'; break;
			case "v:/[a-z]+:\/\/(?:\w+.)?\w+\.\w{2,}(?:[\w\/&=?]+)?$/": $url = ' selected="selected"'; break;
			case "v:/^([123456789][[:digit:]]{3})-(0[1-9]|1[012])-(0[1-9]|[12][[:digit:]]|3[01])$/": $date = ' selected="selected"'; break;
		}
		
		$display = "none";
		if(isset($data["field_type"]) && ($data["field_type"] == '' || $data["field_type"] == 'text')) $display = "block";
		$block = "<div id=\"validate_block\" style=\"display:$display; padding:0; margin:0;\">
		<div class='defaultBold' >".$LANG->line('validation')."</div>
		<div class='itemWrapper'><select name=\"validation\"><option value=\"\"></option>
		<option value='v:/^[0-9]+$/'$numeric>Numeric</option>
		<option value='v:/^[a-z]+$/i'$alpha>Alpha</option>
		<option value='v:/^[a-z0-9]+$/i'$alphanumeric>Alphanumeric</option>
		<option value='v:/^[a-zA-Z][\w\.-]*[a-zA-Z0-9]@[a-zA-Z0-9][\w\.-]*[a-zA-Z0-9]\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z]$/'$email>Email</option>
		<option value='v:/[a-z]+:\/\/(?:\w+.)?\w+\.\w{2,}(?:[\w\/&=?]+)?$/'$url>Url</option>
		<option value='v:/^([123456789][[:digit:]]{3})-(0[1-9]|1[012])-(0[1-9]|[12][[:digit:]]|3[01])$/'$date>Date (yyyy-mm-dd)</option>
		</select></div></div>";
		$r = preg_replace("/(<div\s*id=.date_block.)/", "$block$1", $r);
		
		return $r;
	}
	
	//
	//  Reset $_POST Info for new/updated fields
	//
	function edit_publish_ad_post()
	{
		if(isset($_POST['validation']) && $_POST['validation'] != '')
		{
			$_POST['field_list_items'] = $_POST['validation'];
			unset($_POST['validation']);
		}
		else if(isset($_POST['validation']))
		{
			unset($_POST['validation']);
		}
	}
	
	//
	//  Modify Post for EE Storage
	//
	function modify_post()
	{
		global $DB, $EE, $EXT, $LANG;
		$LANG->fetch_language_file('text_improved');
		
		$field_data = "";
		$query = $DB->query("SELECT f.field_id id, f.field_name name, f.field_label label, f.field_list_items FROM exp_weblog_fields AS f, exp_weblogs AS w WHERE w.weblog_id=".$_POST["weblog_id"]." AND f.group_id=w.field_group AND f.field_type='text'");
		if($query->num_rows==0) return;
		foreach($query->result as $field)
		{
			if(isset($_POST['field_id_'.$field['id']]) && $_POST['field_id_'.$field['id']] != "" && substr($field['field_list_items'], 0, 2) == "v:" && !preg_match(substr($field['field_list_items'], 2), $_POST['field_id_'.$field['id']]))
			{
				$err = $LANG->line('validation_error_'.$field['field_list_items']);
				if($err == "" && isset($this->settings['error_messages']))
				{
					$messages = preg_split("/[\r\n]+/", $this->settings['error_messages']);
					foreach($messages as $m)
					{
						list($pattern, $message) = explode(" l:\"", $m);
						if($pattern == $field['field_list_items'])
						{
							$err = preg_replace("/\"$/", "", $message);
							break;
						}
					}
				}
				if($err == "") $err = $LANG->line('validation_error');
				$EE->new_entry_form('preview', str_replace("%f", $field['label'], $err));
				$EXT->end_script = TRUE;
			}
		}
	}

}

?>